@echo off

:setup
:macro
:main

REM detect if first argument is a existing function in this file
REM detect if first argument is a file in %bfw.root%\lib
REM demo should be case
for %%a in ( %* ) do ( for %%b in ( /h /? -h -? help --help ) do ( if "[%%a]" EQU "[%%b]" ( Call :%~n0-help & exit /b 1 ) ) )
for %%a in ( %* ) do ( if "[%%a]" EQU "[demo]" ( Call :%~n0-demo & exit /b 1 ) ) 
if "[%~n0]" EQU "[bfw]" if "[%~1]" EQU "[]" ( echo %~n0 needs at least one argument & exit /b 1 )
REM if "[%~n0]" EQU "[bfw]" if "[%~1]" EQU "[]" if "[%~2]" EQU "[]" ( echo %~n0 needs at least two argument & exit /b 1 )
if "[%~n0]" EQU "[bfw]" ( Call :ShiftedArgumentCaller %* ) else ( Call :%~n0 %* )

:end


GoTo :EOF


:GetSubstringIndex-demo

Call :ClearVariablesByPrefix testvar

REM GoTo :GetSubstringIndex-demo-skip1
REM GoTo :GetSubstringIndex-demo-skip2
REM GoTo :GetSubstringIndex-demo-skip3
REM GoTo :GetSubstringIndex-demo-skip4
REM GoTo :GetSubstringIndex-demo-skip5

echo.&echo Creating test array using ReplaceString, string of 100 F, TEST search pattern, rolling location 0 to 100
set testvar=FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
set /a testvar_index=0
:GetSubstringIndex-demo-loop1
Call :ReplaceString "%testvar%" "TEST" testvar[%testvar_index%] %testvar_index% 4
set /a testvar.ubound=%testvar_index%
set /a testvar_index+=1
if %testvar_index% LEQ 100 GoTo :GetSubstringIndex-demo-loop1

echo.&echo Testing GetSubstringIndex, string of 100 F, byref array variable
set /a testvar_index=0
:GetSubstringIndex-demo-loop2
Call :GetSubstringIndex "testvar[%testvar_index%]" TEST 0 
call echo Index %testvar_index% : result %errorlevel%  #%%testvar[%testvar_index%]%%
set /a testvar_index+=1
if %testvar_index% LEQ %testvar.ubound% GoTo :GetSubstringIndex-demo-loop2

echo.&echo Testing GetSubstringIndex, string of 100 F,  expanded array variable
set /a testvar_index=0
:GetSubstringIndex-demo-loop3
Call :GetSubstringIndex "%%testvar[%testvar_index%]%%" TEST 0 
call echo Index %testvar_index% : result %errorlevel%  #%%testvar[%testvar_index%]%%
set /a testvar_index+=1
if %testvar_index% LEQ %testvar.ubound% GoTo :GetSubstringIndex-demo-loop3


:GetSubstringIndex-demo-skip1
REM GoTo :EOF
Call :ClearVariablesByPrefix testvar


echo.&echo Creating test array using ReplaceString, random alphanumeric 100 with CreateRandomStringPS, TEST search pattern, rolling location 0 to 100
Call :CreateRandomStringPS 100 testvar
set /a testvar_index=0
:GetSubstringIndex-demo-loop4
Call :ReplaceString "%testvar%" "TEST" testvar[%testvar_index%] %testvar_index% 4
call echo Index %testvar_index% : result %errorlevel%  #%%testvar[%testvar_index%]%%
set /a testvar.ubound=%testvar_index%
set /a testvar_index+=1
if %testvar_index% LEQ 100 GoTo :GetSubstringIndex-demo-loop4


echo.&echo Testing GetSubstringIndex, random alphanumeric, TEST search pattern, rolling location 0 to 100, byref array variable
set /a testvar_index=0
:GetSubstringIndex-demo-loop5
Call :GetSubstringIndex "testvar[%testvar_index%]" TEST 0 
call echo Index %testvar_index% : result %errorlevel%  #%%testvar[%testvar_index%]%%
set /a testvar_index+=1
if %testvar_index% LEQ %testvar.ubound% GoTo :GetSubstringIndex-demo-loop5


echo.&echo Testing GetSubstringIndex, random alphanumeric, TEST search pattern, rolling location 0 to 100, expanded array variable
set /a testvar_index=0
:GetSubstringIndex-demo-loop6
Call :GetSubstringIndex "%%testvar[%testvar_index%]%%" TEST 0 
call echo Index %testvar_index% : result %errorlevel%  #%%testvar[%testvar_index%]%%
set /a testvar_index+=1
if %testvar_index% LEQ %testvar.ubound% GoTo :GetSubstringIndex-demo-loop6

:GetSubstringIndex-demo-skip2
REM GoTo :EOF
Call :ClearVariablesByPrefix testvar


echo.&echo Creating test array using ReplaceString, random alphanumeric with space with punctuation but no poison with CreateRandomStringPS, TEST search pattern, rolling location 0 to 100
Call :CreateRandomStringPS PUNCTUATION NOPOISON SPACE 100 testvar
set /a testvar_index=0
:GetSubstringIndex-demo-loop7
Call :ReplaceString "%testvar%" "TEST" testvar[%testvar_index%] %testvar_index% 4
call echo Index %testvar_index% : result %errorlevel%  #%%testvar[%testvar_index%]%%
set /a testvar.ubound=%testvar_index%
set /a testvar_index+=1
if %testvar_index% LEQ 100 GoTo :GetSubstringIndex-demo-loop7


echo.&echo Testing GetSubstringIndex, random alphanumeric, TEST search pattern, rolling location 0 to 100, byref array variable
set /a testvar_index=0
:GetSubstringIndex-demo-loop8
Call :GetSubstringIndex "testvar[%testvar_index%]" TEST 0 
call echo Index %testvar_index% : result %errorlevel%  #%%testvar[%testvar_index%]%%
set /a testvar_index+=1
if %testvar_index% LEQ %testvar.ubound% GoTo :GetSubstringIndex-demo-loop8


echo.&echo Testing GetSubstringIndex, random alphanumeric, TEST search pattern, rolling location 0 to 100, expanded array variable
set /a testvar_index=0
:GetSubstringIndex-demo-loop9
Call :GetSubstringIndex "%%testvar[%testvar_index%]%%" TEST 0 
call echo Index %testvar_index% : result %errorlevel%  #%%testvar[%testvar_index%]%%
set /a testvar_index+=1
if %testvar_index% LEQ %testvar.ubound% GoTo :GetSubstringIndex-demo-loop9

:GetSubstringIndex-demo-skip3
REM GoTo :EOF
Call :ClearVariablesByPrefix testvar


echo.&echo Creating test array using ReplaceString, random alphanumeric with space with punctuation with extended but no poison with CreateRandomStringPS, TEST search pattern, rolling location 0 to 100
Call :CreateRandomStringPS PUNCTUATION NOPOISON SPACE EXTENDED 100 testvar
set /a testvar_index=0
:GetSubstringIndex-demo-loop10
Call :ReplaceString "%testvar%" "TEST" testvar[%testvar_index%] %testvar_index% 4
call echo Index %testvar_index% : result %errorlevel%  #%%testvar[%testvar_index%]%%
set /a testvar.ubound=%testvar_index%
set /a testvar_index+=1
if %testvar_index% LEQ 100 GoTo :GetSubstringIndex-demo-loop10


echo.&echo Testing GetSubstringIndex, random alphanumeric, TEST search pattern, rolling location 0 to 100, byref array variable
set /a testvar_index=0
:GetSubstringIndex-demo-loop11
Call :GetSubstringIndex "testvar[%testvar_index%]" TEST 0 
call echo Index %testvar_index% : result %errorlevel%  #%%testvar[%testvar_index%]%%
set /a testvar_index+=1
if %testvar_index% LEQ %testvar.ubound% GoTo :GetSubstringIndex-demo-loop11


echo.&echo Testing GetSubstringIndex, random alphanumeric, TEST search pattern, rolling location 0 to 100, expanded array variable
set /a testvar_index=0
:GetSubstringIndex-demo-loop12
Call :GetSubstringIndex "%%testvar[%testvar_index%]%%" TEST 0 
call echo Index %testvar_index% : result %errorlevel%  #%%testvar[%testvar_index%]%%
set /a testvar_index+=1
if %testvar_index% LEQ %testvar.ubound% GoTo :GetSubstringIndex-demo-loop12

:GetSubstringIndex-demo-skip4
REM GoTo :EOF
Call :ClearVariablesByPrefix testvar


echo.&echo Creating test array using ReplaceString, 1000 long random alphanumeric with punctuation but no poison with CreateRandomStringPS, TEST search pattern, rolling location 0 to 100
Call :CreateRandomStringPS PUNCTUATION NOPOISON SPACE EXTENDED 1000 testvar
set /a testvar_index=0
:GetSubstringIndex-demo-loop13
Call :ReplaceString "%testvar%" "TEST" testvar[%testvar_index%] %testvar_index% 4
call echo Index %testvar_index% : result %errorlevel%  #%%testvar[%testvar_index%]%%
set /a testvar.ubound=%testvar_index%
set /a testvar_index+=1
if %testvar_index% LEQ 1000 GoTo :GetSubstringIndex-demo-loop13


echo.&echo Testing GetSubstringIndex, random alphanumeric, TEST search pattern, rolling location 0 to 100, byref array variable
set /a testvar_index=0
:GetSubstringIndex-demo-loop14
Call :GetSubstringIndex "testvar[%testvar_index%]" TEST 0 
call echo Index %testvar_index% : result %errorlevel%  #%%testvar[%testvar_index%]%%
set /a testvar_index+=1
if %testvar_index% LEQ %testvar.ubound% GoTo :GetSubstringIndex-demo-loop14


echo.&echo Testing GetSubstringIndex, random alphanumeric, TEST search pattern, rolling location 0 to 100, expanded array variable
set /a testvar_index=0
:GetSubstringIndex-demo-loop15
Call :GetSubstringIndex "%%testvar[%testvar_index%]%%" TEST 0 
call echo Index %testvar_index% : result %errorlevel%  #%%testvar[%testvar_index%]%%
set /a testvar_index+=1
if %testvar_index% LEQ %testvar.ubound% GoTo :GetSubstringIndex-demo-loop15

:GetSubstringIndex-demo-skip5
REM GoTo :EOF
Call :ClearVariablesByPrefix testvar

echo on 
echo.&echo Creating test array using ReplaceString, 4079 long random alphanumeric with punctuation but no poison with CreateRandomStringPS, TEST search pattern, rolling location 0 to 100
Call :CreateRandomStringPS PUNCTUATION NOPOISON SPACE EXTENDED 4079 testvar
set /a testvar_index=0
:GetSubstringIndex-demo-loop16
Call :ReplaceString "%testvar%" "TEST" testvar[%testvar_index%] %testvar_index% 4
call echo Index %testvar_index% : result %errorlevel%  #%%testvar[%testvar_index%]%%
set /a testvar.ubound=%testvar_index%
set /a testvar_index+=1
if %testvar_index% LEQ 4079 GoTo :GetSubstringIndex-demo-loop16


echo.&echo Testing GetSubstringIndex, random alphanumeric, TEST search pattern, rolling location 0 to 100, byref array variable
set /a testvar_index=0
:GetSubstringIndex-demo-loop17
Call :GetSubstringIndex "testvar[%testvar_index%]" TEST 0 
call echo Index %testvar_index% : result %errorlevel%  #%%testvar[%testvar_index%]%%
set /a testvar_index+=1
if %testvar_index% LEQ %testvar.ubound% GoTo :GetSubstringIndex-demo-loop17


echo.&echo Testing GetSubstringIndex, random alphanumeric, TEST search pattern, rolling location 0 to 100, expanded array variable
set /a testvar_index=0
:GetSubstringIndex-demo-loop18
Call :GetSubstringIndex "%%testvar[%testvar_index%]%%" TEST 0 
call echo Index %testvar_index% : result %errorlevel%  #%%testvar[%testvar_index%]%%
set /a testvar_index+=1
if %testvar_index% LEQ %testvar.ubound% GoTo :GetSubstringIndex-demo-loop18

:GetSubstringIndex-demo-skip6
REM GoTo :EOF
Call :ClearVariablesByPrefix testvar

echo on 
echo.&echo Creating test array using ReplaceString, 4079 long random alphanumeric with punctuation but no poison with CreateRandomStringPS, TEST search pattern, rolling location 0 to 100
Call :CreateRandomStringPS PUNCTUATION NOPOISON SPACE EXTENDED 4079 testvar
set /a testvar_index=0
:GetSubstringIndex-demo-loop16
Call :ReplaceString "%testvar%" "TEST" testvar[%testvar_index%] %testvar_index% 4
call echo Index %testvar_index% : result %errorlevel%  #%%testvar[%testvar_index%]%%
set /a testvar.ubound=%testvar_index%
set /a testvar_index+=1
if %testvar_index% LEQ 4079 GoTo :GetSubstringIndex-demo-loop16


echo.&echo Testing GetSubstringIndex, random alphanumeric, TEST search pattern, rolling location 0 to 100, byref array variable
set /a testvar_index=0
:GetSubstringIndex-demo-loop17
Call :GetSubstringIndex "testvar[%testvar_index%]" TEST 0 
call echo Index %testvar_index% : result %errorlevel%  #%%testvar[%testvar_index%]%%
set /a testvar_index+=1
if %testvar_index% LEQ %testvar.ubound% GoTo :GetSubstringIndex-demo-loop17


echo.&echo Testing GetSubstringIndex, random alphanumeric, TEST search pattern, rolling location 0 to 100, expanded array variable
set /a testvar_index=0
:GetSubstringIndex-demo-loop18
Call :GetSubstringIndex "%%testvar[%testvar_index%]%%" TEST 0 
call echo Index %testvar_index% : result %errorlevel%  #%%testvar[%testvar_index%]%%
set /a testvar_index+=1
if %testvar_index% LEQ %testvar.ubound% GoTo :GetSubstringIndex-demo-loop18

GoTo :EOF

::Usage Call :ReplaceString SourceString ReplaceString OutputString StartIndex len
:ReplaceString
set "_ReplaceString_prefix=_RS"
setlocal enabledelayedexpansion
if defined %~1 call set _RS_Input=!%~1!
if not defined _RS_Input set _RS_Input=%~1
if defined %~2 call set _RS_Replace=!%~2!
if not defined _RS_Replace set _RS_Replace=%~2
if defined %~3 call set _RS_Output=!%~3!
if not defined _RS_Output set _RS_Output=%~3
set /a _RS_StartIndex=%~4
set /a _RS_len=%~5
set /a _RS_RemainIndex=%_RS_StartIndex%+%_RS_len%
set _RS_Intermetiate=!_RS_Input:~,%_RS_StartIndex%!!_RS_Replace!!_RS_Input:~%_RS_RemainIndex%!
for /f "tokens=1* delims=" %%a in ('echo.!_RS_Intermetiate!') do endlocal & set %_RS_Output%=%%a
Call :ClearVariablesByPrefix %_ReplaceString_prefix% _ReplaceString_prefix & GoTo :EOF

::Usage Call :GetSubstringIndex InputString SearchString StartIndex ... InputStringN SearchStringN StartIndexN 
:GetSubstringIndex
set "_GetSubstringIndex_prefix=_GSSI"
set /a _GSSI_StartIndex=%~3
if defined %~1 call set _GSSI_Input=%%%~1%%
if not defined _GSSI_Input set _GSSI_Input=%~1
if defined %~2 call set _GSSI_Search=%%%~2%%
if not defined _GSSI_Search set _GSSI_Search=%~2
Call :len _GSSI_Input _GSSI_Input_len
Call :len _GSSI_Search _GSSI_Search_len
set /a _GSSI_Input_len-=1
set /a _GSSI_min_search=(%_GSSI_Search_len%*2)
setlocal enabledelayedexpansion
:GetSubstringIndex-loop
set /a _GSSI_HalfInputLen=%_GSSI_Search_len%+(%_GSSI_Input_len%/2)
if %_GSSI_HalfInputLen% LEQ %_GSSI_min_search% ( set /a _GSSI_max_search=%_GSSI_StartIndex%+%_GSSI_min_search%+1 & GoTo :GetSubstringIndex-loop2 )
set /a _GSSI_Middle=%_GSSI_StartIndex%+%_GSSI_HalfInputLen%
set /a _GSSI_HalfInputLenPLUSSearchLenMINUSOne=%_GSSI_HalfInputLen%+%_GSSI_Search_len%-1
set "_GSSI_FirstHalf=!_GSSI_Input:~%_GSSI_StartIndex%,%_GSSI_HalfInputLenPLUSSearchLenMINUSOne%!
set "_GSSI_SecondHalf=!_GSSI_Input:~%_GSSI_Middle%,%_GSSI_HalfInputLen%!
set "_GSSI_FirstResult=!_GSSI_FirstHalf:%_GSSI_Search%=!"
set "_GSSI_SecondResult=!_GSSI_SecondHalf:%_GSSI_Search%=!"
if !_GSSI_FirstHalf! NEQ !_GSSI_FirstResult! ( set /a _GSSI_Input_len=%_GSSI_HalfInputLen% & GoTo :GetSubstringIndex-loop )
if !_GSSI_SecondHalf! NEQ !_GSSI_SecondResult! ( set /a _GSSI_StartIndex=%_GSSI_Middle% & GoTo :GetSubstringIndex-loop )
set /a _GSSI_StartIndex=-1 & GoTo :GetSubstringIndex-end
:GetSubstringIndex-loop2
set "_GSSI_FinalSearch=!_GSSI_Input:~%_GSSI_StartIndex%,%_GSSI_Search_len%!
set /a "_GSSI_debug_remain_len=%_GSSI_max_search%-%_GSSI_StartIndex%"+1
if !_GSSI_FinalSearch! EQU !_GSSI_Search! GoTo :GetSubstringIndex-end
set /a _GSSI_StartIndex+=1
if %_GSSI_StartIndex% LEQ %_GSSI_max_search% GoTo :GetSubstringIndex-loop2
set /a _GSSI_StartIndex=-1
:GetSubstringIndex-end
endlocal & Call :ClearVariablesByPrefix %_GetSubstringIndex_prefix% _GetSubstringIndex_prefix & exit /b %_GSSI_StartIndex%

::Usage Call :CreateRandomStringPS [NONUMBERS] [NOUPPERCASE] [NOUPPERCASE] [SPACE] [PUNCTUATION] [NOPOISON] [POISON] [EXTENDED] [CONTROL] [RESET] StringLenght1 OutputVariable1 StringLenght2 OutputVariable2 ... StringLenghtN OutputVariableN
::You can your CLEAR in front of the switches to clear them
:CreateRandomStringPS
set "_CreateRandomStringPS_prefix=_CRS"
set "_CRS_SetList=NONUMBERS NOUPPERCASE NOLOWERCASE SPACE PUNCTUATION NOPOISON EXTENDED CONTROL NOPOISON POISON"
if "[%~1]" EQU "[RESET]" ( for %%a in (%_CRS_SetList%) do ( set "_CRS_%%a=" ) & shift & GoTo :CreateRandomStringPS )
for %%a in (%_CRS_SetList%) do if "[%%a]" EQU "[%~1]" ( set "_CRS_%%a=true" & shift & GoTo :CreateRandomStringPS ) else ( if "[CLEAR%%a]" EQU "[CLEAR%~1]" ( set "_CRS_%%a=" & shift & GoTo :CreateRandomStringPS ) )
set /a _CRS_Len=%~1
set "_CRS_Output=%~2"
set "_CRS_CurrentSet="
if not defined _CRS_NONUMBERS set "_CRS_CurrentSet=%_CRS_CurrentSet% + 48..57"
if not defined _CRS_NOUPPERCASE set "_CRS_CurrentSet=%_CRS_CurrentSet% + 65..90"
if not defined _CRS_NOLOWERCASE set "_CRS_CurrentSet=%_CRS_CurrentSet% + 97..122"
if defined _CRS_SPACE set "_CRS_CurrentSet=%_CRS_CurrentSet% + 32"
if defined _CRS_PUNCTUATION if not defined _CRS_NOPOISON ( set "_CRS_CurrentSet=%_CRS_CurrentSet% + 33..47 + 58..64 + 91..96 + 123..126" ) else ( set "_CRS_CurrentSet=%_CRS_CurrentSet%+ 35..36 + 39 + 42..47 + 58..59 + 61 + 63..64 + 91..93 + 95..96 + 123 + 125 + 126" )
if defined _CRS_POISON if not defined _CRS_PUNCTUATION  set "_CRS_CurrentSet=%_CRS_CurrentSet% + 33 + 34 + 37 + 38 + 40 + 41 + 60 + 62 + 94 + 124"
if defined _CRS_EXTENDED set "_CRS_CurrentSet=%_CRS_CurrentSet% + 128..255"
if defined _CRS_CONTROL set "_CRS_CurrentSet=%_CRS_CurrentSet% + 0..31 + 127"
for /f "tokens=1* delims=" %%a in ('powershell -command "-join (1..%_CRS_Len% | ForEach-Object { %_CRS_CurrentSet:~3% | Get-Random } | ForEach-Object { [char]$_ })" 2^>nul') do set %_CRS_Output%=%%a
if "[%~3]" NEQ "[]" if "[%~4]" NEQ "[]" ( shift & shift & GoTo :CreateRandomStringPS )
Call :ClearVariablesByPrefix %_CreateRandomStringPS_prefix% _CreateRandomStringPS_prefix & GoTo :EOF

:: Usage Call :ClearVariablesByPrefix myPrefix
:ClearVariablesByPrefix
if "[%~1]" NEQ "[]" for /f "tokens=1 delims==" %%a in ('set "%~1" 2^>nul') do set %%a=
if "[%~2]" NEQ "[]" shift & GoTo :ClearVariablesByPrefix
GoTo :EOF


:len <resultVar> <stringVar>
(   
    setlocal EnableDelayedExpansion
    (set^ tmp=!%~1!)
    if defined tmp (
        set "len=1"
        for %%P in (4096 2048 1024 512 256 128 64 32 16 8 4 2 1) do (
            if "!tmp:~%%P,1!" NEQ "" ( 
                set /a "len+=%%P"
                set "tmp=!tmp:~%%P!"
            )
        )
    ) ELSE (
        set len=0
    )
)
( 
    endlocal
    set "%~2=%len%"
    exit /b
)
REM https://stackoverflow.com/a/5841587

:EchoWithoutNewline
echo|set /p="%*"
GoTo :EOF
